(* $Id: lib_string.ml,v 1.2 2012/05/22 15:11:17 fclement Exp $ *)

let first_char s =
  if String.length s > 0 then s.[0] else invalid_arg "first_char"
;;

(* Break a string into words that are sep separated
   for instance
   break `|` "a|b" -> ["a"; "b"]
   break `|` "|" -> [""; ""] *)
let break sep s =
  let res = ref [] in
  let max = String.length s - 1 in
  let end_pos = ref max in
  for i = max downto 0 do
   let c = s.[i] in
   if c = sep then begin
     res := String.sub s (i + 1) (!end_pos - i) :: !res;
     end_pos := i - 1
   end
  done;
  if max > - 1 then res := String.sub s 0 (!end_pos + 1) :: !res;
  !res
;;

let substitute_char c1 c2 s =
  let s = String.copy s in
  for i = 0 to String.length s - 1 do
   if s.[i] = c1 then s.[i] <- c2
  done;
  s
;;

let quoted s = String.concat "" ["\""; s; "\""];;
let quoted_escaped s = String.concat "" ["\""; String.escaped s; "\""];;
